#include <mpi.h>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>

using namespace std;

struct mypair {
  int a,final_pos;
};

//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>
void vecperm_init(vector<int> &A, vector<int> &P,
                  int N,MPI_Comm comm) {
  int myrank, size;
  MPI_Comm_rank(comm,&myrank);
  MPI_Comm_size(comm,&size);
  vector<int> Nh(size);
  for (int j=0; j<size; j++) 
    Nh[j] = N/size+(j<N%size);

  vector<mypair> AP(N);
  // Bsol.resize(N);
  if (!myrank) {
    for (int j=0; j<N; j++) {
      AP[j].a = rand()%1000;
      AP[j].final_pos = j;
    }
    random_shuffle(AP.begin(),AP.end());
  }
  MPI_Bcast(&AP[0],N*sizeof(mypair),MPI_CHAR,0,MPI_COMM_WORLD);

  // for (int j=0; j<N; j++)
  //  Bsol[j] = AP[j].a;

  int Nhere = Nh[myrank];
  A.resize(Nhere);
  P.resize(Nhere);
  int base=0;
  for (int j=0; j<myrank; j++) 
    base += Nh[j];
  // my_displ = base;

  for (int j=0; j<Nhere; j++) {
    A[j] = AP[base+j].a;
    P[j] = AP[base+j].final_pos;
  }  
}
