//$Id: mybcast.cpp,v 1.4 2004/07/24 00:02:02 mstorti Exp $
#include <mpi.h>
#include <mpe.h>
#include <cstdio>
#include <cmath>
#include <vector>

using namespace std;

int MAX;

int check_sum(vector<int> &buff) {
  int check_sum=0;
  int n = buff.size();
  for (int j=0; j<n; j++) {
    unsigned int w = buff[j];
    check_sum += w % MAX;
    check_sum = check_sum % MAX;
  }
  return check_sum;
}

int main(int argc, char **argv) {
  MAX = int(sqrt(double(INT_MAX)));

  MPI_Init(&argc,&argv);
  MPE_Init_log();

  int  myrank, size;
  MPI_Comm_rank(MPI_COMM_WORLD,&myrank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  int start_comp = MPE_Log_get_event_number();
  int end_comp = MPE_Log_get_event_number();
  int start_bcast = MPE_Log_get_event_number();
  int end_bcast = MPE_Log_get_event_number();

  int n=1000000;
  vector<int> buff(n);

  if (!myrank) {
    for (int j=0; j<n; j++) buff[j] = rand();
  }
 
  int first=0, last=size;
  MPI_Status status;
  while (last-first>1) {
    int middle = (first+last)/2;
    if (myrank==first) {
      printf("[%d] send to %d\n",myrank,middle);
      MPI_Send(&buff[0],n,MPI_INT,middle,0,MPI_COMM_WORLD);
    } else if (myrank==middle) {
      printf("[%d] receive from %d\n",myrank,first);
      MPI_Recv(&buff[0],n,MPI_INT,first,MPI_ANY_TAG,
	       MPI_COMM_WORLD,&status);
    }
    if (myrank<middle) last  = middle;
    else first = middle;
  }
  
#if 1
  int cs0, cs = check_sum(buff);
  if (!myrank) cs0 = cs;
  MPI_Bcast(&cs0,1,MPI_INT,0,MPI_COMM_WORLD);
  int OK, OK1;
  OK1 = (cs==cs0);
  MPI_Reduce(&OK1,&OK,1,MPI_INT,MPI_LAND,0,MPI_COMM_WORLD);
  if (!myrank) printf("check sum OK? %d\n",OK);
#endif
    
  MPE_Finish_log("primes");
  MPI_Finalize();
}
