// $Id curspar-1.0.0-17-g6699541 Fri Jun 15 13:17:11 2007 -0300$
//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---: 
//  Solves Ax=b using Richardson
//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---: 
#include <cstdio>
#include <cassert>
#include <cmath>

void read_matrix(char *file,
		 int ncmax,int *I,int *J,double * AIJ,int &nc,
		 int nmax,double *B,double *X,int &n) {
  FILE *fid=fopen(file,"r");
  assert(fid);

  int nread = fscanf(fid,"%d",&n);
  assert(n<nmax);

  for (int j=0; j<n; j++) {
    double b, x;
    nread = fscanf(fid,"%lf %lf",&b,&x);
    assert(nread==2);
    B[j] = b;
    X[j] = x;
  }

  nc = 0;
  while (1) {
    int i,j;
    double a;
    nread = fscanf(fid,"%d %d %lf",&i,&j,&a);
    if (nread == EOF) break;
    assert(nc<ncmax);
    assert(i>=0 && i<n);
    assert(j>=0 && j<n);
    I[nc] = i;
    J[nc] = j;
    AIJ[nc] = a;
    nc++;
  }
}

extern "C" {
  void read_matrix_(char *file,
                    int &ncmax,int *I,int *J,double * AIJ,int &nc,
                    int &nmax,double *B,double *X,int &n) {
    read_matrix(file,ncmax,I,J,AIJ,nc,nmax,B,X,n);
  }
}
