#include <vector>
#include <cmath>

using namespace std;

int even(int x) {
  return !(x % 2);
}

int odd(int x) {
  return (x % 2);
}

typedef int (*pred_fun)(int x);

void filter(vector<int> &v,vector<int> &vf,pred_fun pred) {
  vf.clear();
  int n = v.size();
  for (int j=0; j<n; j++) {
    if (pred(v[j])) vf.push_back(v[j]);
  }
}

int main() {
#define N 10
  srand(time(NULL));
  vector<int> v(N),vf;
  for (int j=0; j<N; j++)
    v[j] = rand()%20;

  printf("v: ");
  for (int j=0; j<N; j++)
    printf("%d ",v[j]);
  printf("\n");

  filter(v,vf,even);

  printf("vf: ");
  for (int j=0; j<vf.size(); j++)
    printf("%d ",vf[j]);
  printf("\n");

  filter(v,vf,odd);

  printf("vf: ");
  for (int j=0; j<vf.size(); j++)
    printf("%d ",vf[j]);
  printf("\n");
}
