// $Id: tsp1d.cpp,v 1.2 2004/10/10 14:33:14 mstorti Exp $
//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---: 
//  Generates all complete paths from partial paths
//---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---:---<*>---: 
#include <cstdio>
#include <cassert>
#include <cmath>
#include <cfloat>
#include <cstring>

using namespace std;

void print_path(int *path,int Nv) {
  printf("(");
  for (int j=0; j<Nv-1; j++) 
    printf("%d,",path[j]);
  printf("%d)\n",path[Nv-1]);
}

int next_path(int *path,int Nv,int Np=0) {
  for (int j=Nv-1; j>=Np; j--) {
    if (path[0]==j) {
      for (int k=0; k<j; k++) path[k] = path[k+1];
      path[j] = j;
    } else {
      int k;
      for (k=0; k<Nv-1; k++) 
	if (path[k]==j) break;
      path[k] = path[k-1];
      path[k-1] = j;
      return 1;
    }
  }
  return 0;
}

double dist(int *path, int Nv, double *d) {
  double D=0.0;
  for (int j=0; j<Nv; j++) {
    int k = j+1;
    if (j==Nv-1) k=0;
    int J = path[j];
    int K = path[k];
    D += d[Nv*J+K];
  }
  return D;
}

int main() {
  int Nv=4, Np=3;

  int *path= new int[Nv];
  int *ppath= new int[Nv];

  for (int j=0; j<Nv; j++) ppath[j]=j; //L-next-pathpc-b
  while(1) {
    printf("parcial path: ");
    print_path(ppath,Np);
    memcpy(path,ppath,Nv*sizeof(int));
    while (1) {
      printf("complete path: ");
      print_path(path,Nv);
      if(!next_path(path,Nv,Np)) break;
    }
    if(!next_path(ppath,Np)) break;
  }
                                       //L-next-pathpc-e

  for (int j=0; j<Nv; j++) ppath[j]=j; //L-next-path-sc-b
  while(1) {
    memcpy(path,ppath,Nv*sizeof(int));
    while (1) {
      // do something with complete path ....
      if(!next_path(path,Nv,Np)) break;
    }
    if(!next_path(ppath,Np)) break;
  }
                                      //L-next-path-sc-b
}
