// $Id: tsplib.cpp,v 1.2 2004/10/10 14:33:14 mstorti Exp $
#include <cstdio>
#include <cassert>
#include <cmath>
#include <cfloat>
#include <cstring>
#include <mpi.h>

void print_path(int *path,int Nv) {
  printf("(");
  for (int j=0; j<Nv-1; j++) 
    printf("%d,",path[j]);
  printf("%d)\n",path[Nv-1]);
}

int next_path(int *path,int N,int Np=0) {
  int j;
  for (j=0; j<N-Np; j++) if (path[j] != N-1-j) break;
  if (j==N-Np) return 0;
  else {
    if (j>0) {
      for (int k=0; k<N-j; k++) path[k] = path[k+j];
      for (int k=N-j; k<N; k++) path[k] = k;
    }
  }

  int jj=N-1-j;
  // Tries to move vertex `jj' one step to the head
  // Look where is 'jj'
  int k;
  for (k=1; k<N-1; k++) if (path[k] == jj) break;
  assert(k<N);
  // Exchange 'jj' with previous position
  path[k] = path[k-1];
  path[k-1] = jj;
  return 1;
}

double dist(int *path, int N, double *d) {
  double D=0.0;
  for (int j=0; j<N; j++) {
    int k = j+1;
    if (j==N-1) k=0;
    int J = path[j];
    int K = path[k];
    D += d[N*J+K];
  }
  return D;
}

extern "C" {
  void print_path__(int *path,int *N) {
    print_path(path,*N);
  }

  void next_path__(int *path,int *N,int *Np,int *ok) {
    *ok = next_path(path,*N,*Np);
  }

  
  void dist_(int *path, int *N, double *d, double *D) {
    *D = dist(path, *N,d);
  }
}
